﻿-- Author      : Kali
local HeraldSpeaks = ""

local frame = CreateFrame("Frame")

local msgType = {
["pvp"] = "BATTLEGROUND",
["arena"] = "PARTY",
["party"] = "PARTY",
["raid"] = "RAID",
}

local antispam = {}

function HeraldChatter()
	local inInstance, instanceType = IsInInstance()
	local HeraldType = ""

	if HeraldSay==true then
		HeraldType = "SAY"
	elseif inInstance == 1 and instanceType ~= "none" then
		HeraldType = msgType[instanceType]
	end

	if (HeraldRW == true and IsRaidOfficer()==1 and instanceType=="raid") then
		HeraldType = "RAID_WARNING"
	end
	SendChatMessage(HeraldSpeaks, HeraldType)
end

local function handler (msg)
	if msg == '' then
		HeraldHelp()
	elseif msg == 'on' then
		Herald = true
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		print("Your Herald is currently: "..getStatus(Herald))
	elseif msg == 'off' then
		Herald = false
		frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		print("Your Herald is currently: "..getStatus(Herald))
	elseif msg == 'say' then
		HeraldSay = true
		print("Your Herald is announcing on "..CheckStatus().." .")
	elseif msg == 'rw' then
		HeraldRW = not HeraldRW
		print("Your Herald is announcing on "..CheckStatus().." .")
	elseif msg == 'group' then
		HeraldSay = false
		print("Your Herald is announcing on "..CheckStatus().." .")
	elseif msg == 'status' then
		print("Your Herald is currently: "..getStatus(Herald))
		print("Your Herald is speaking through: "..CheckStatus())
	end
end

SlashCmdList["Herald"] = handler;
SLASH_Herald1 = "/Herald"

function HeraldHelp()
	print("Your Herald is currently: "..getStatus(Herald))
	print("To check the status: /herald status")
	print("To have your Herald speak: /herald on")
	print("To silence your Herald: /herald off")
	print("To announce in says: /herald say")
	print("To announce in group: /herald group")
	print("To announce on raid warnings: /herald rw")
end

function getStatus(cond)
	if cond==true then
		return "|cffff0000Speaking|r"	
	else
		return "|cffff0000Silent|r"
	end
end

function CheckStatus()
	if (HeraldRW == true and IsRaidOfficer()==1) then
		return "|cffff0000Raid Warnings|r"
	elseif HeraldSay == false then
		return "|cffff0000Group|r"
	end
	return "|cffff0000Says|r"
end

local HeraldSpells = {
	[54711] = true, -- Scrapbot
	[22700] = true, -- Field Repair Bot 74A
	[44389] = true, -- Field Repair Bot 110G
	[67826] = true, -- Jeeves
	[87915] = true, -- Goblin BBQ
	[87643] = true, -- Broiled Dragon Feast
	[87644] = true, -- Seafood Magnifique Feast
	[92649] = true, -- Cauldron of Battle
	[92712] = true, -- Big Cauldron of Battle
	[92827] = true, -- Ritual of Refreshment rank 3 aka mage table
	[92824] = true, -- Ritual of Refreshment rank 2 aka mage table
	[29893] = true, -- Ritual of Souls aka Lock cookies
	[698] = true, -- Ritual of Summoning
	[54710] = true, -- MOLL-E aka Mailbox
}

local HeraldGResBank = {
	[83968] = true, -- Mass Resurrection
	[83958] = true, -- Mobile Banking
}

frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")

frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		if Herald == nil then
			Herald = true
		end
		if HeraldSay == nil then
			HeraldSay = true
		end
		if HeraldRW == nil then
			HeraldRW = false
		end
		
		if Herald == true then
			frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end

	else
		local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, spellName = ...		
		if (Herald == true and (UnitInParty(sourceName) or UnitInRaid(sourceName)) and (event=="SPELL_CAST_SUCCESS"  or event=="SPELL_CAST_START") and GetNumGroupMembers()>0 and (HeraldSpells[spellID] or HeraldGResBank[spellID])) then
			if HeraldSpells[spellID] then
				HeraldSpeaks = "> "..sourceName.." creates "..GetSpellLink(spellID).." <"
			elseif HeraldGResBank[spellID] then
				HeraldSpeaks = "> "..sourceName.." is casting "..GetSpellLink(spellID).." <"
			end	
			if (antispam[HeraldSpeaks]==nil) then
				antispam[HeraldSpeaks] = time()
				HeraldChatter(HeraldSpeaks)
			elseif (time()-antispam[HeraldSpeaks])>12 then
				antispam[HeraldSpeaks] = time()
				HeraldChatter(HeraldSpeaks)
			end
		end
	end
end)